import './lib/jquery-throttle.js';

jQuery(document).ready(function( $ ) {
	$('[data-piotnetforms-dropdown-trigger]').click( function(e) {
	    e.preventDefault();
	    $(this).closest('[data-piotnetforms-dropdown]').find('[data-piotnetforms-dropdown-content]').toggle();
	}); 
	//Upload Font
	$('#piotnetforms-pdf-upload-font').click(function(){
        var image_upload = wp.media({
			title: 'Add Font',
			button: {
				text: 'Insert Font'
			},
			multiple: false
		}).on('select', function() {
			var attachment = image_upload.state().get('selection').first().toJSON();
			jQuery('#piotnetforms-pdf-font-url').val(attachment.url);
		}).open();
		return false;
	});

	$('#piotnetforms-pdf-remove-font').click(function(){
		jQuery('#piotnetforms-pdf-font-url').val('');
		return false;
	});

	$('[data-piotnetforms-add-new-form]').click(function(e){
		let template = $(this).attr('data-piotnetforms-add-new-form');
		$('.piotnetforms-dashboard').addClass('piotnetforms-loading');

		let data = {
			'action': 'piotnetforms_create_form',
			'template': template,
			'title': $('[data-piotnetforms-add-new-form-name]').val()
		};

		$.post(ajaxurl, data, function(response) {
			window.location.href = response;
		});
	});

	$('.post-type-piotnetforms a[href*="post-new.php?post_type=piotnetforms"]').click(function(e){
		e.preventDefault();
		window.location.href = $('[data-piotnetforms-admin-url]').attr('data-piotnetforms-admin-url') + 'edit.php?post_type=piotnetforms&page=piotnetforms-add-new';
	});

	function piotnetformsAdminReplaceQueryParam(param, newval, search) {
		var regex = new RegExp("([?;&])" + param + "[^&;]*[;&]?");
		var query = search.replace(regex, "$1").replace(/&$/, '');

		return (query.length > 2 ? query + "&" : "?") + (newval ? param + "=" + encodeURIComponent(newval) : '');
	}

	$('[data-piotnetforms-dashboard-category]').click(function(){
		$('[data-piotnetforms-dashboard-category]').not(this).removeClass('active');
		$(this).addClass('active');

		let keywords = $('[data-piotnetforms-dashboard-search-input]').length > 0 ? $('[data-piotnetforms-dashboard-search-input]').val().trim().toLowerCase() : '',
			category = $(this).attr('data-piotnetforms-dashboard-category'),
			selector = '',
			url_query = piotnetformsAdminReplaceQueryParam('tab', category, window.location.search),
			request_url = window.location.pathname + url_query;

		window.history.pushState({}, '', request_url);

		$('[name="_wp_http_referer"]').each(function(){
			$(this).val(piotnetformsAdminReplaceQueryParam('tab', category, $(this).val()));
		});

		if (keywords !== '' && category !== 'import') {
			selector = selector + '[data-piotnetforms-dashboard-item-title*="' + keywords + '"]';
		}

		if (category !== 'all') {
			selector = selector + '[data-piotnetforms-dashboard-item-category*="' + category + '"]';
		} else {
			selector = selector + '[data-piotnetforms-dashboard-item-category]:not([data-piotnetforms-dashboard-item-category="import"])';
		}

		$('[data-piotnetforms-dashboard-item-category]').removeClass('active');
		$(document).find(selector).addClass('active');
	});

	$(document).on('keyup change','[data-piotnetforms-dashboard-search-input]', $.debounce( 250, function(){
			let keywords = $(this).val().trim().toLowerCase(),
				category = $('[data-piotnetforms-dashboard-category].active').attr('data-piotnetforms-dashboard-category'),
				selector = '';

			if (keywords !== '' && category !== 'import') {
				selector = selector + '[data-piotnetforms-dashboard-item-title*="' + keywords + '"]';
			}

			if (category !== 'all') {
				selector = selector + '[data-piotnetforms-dashboard-item-category*="' + category + '"]';
			} else {
				selector = selector + '[data-piotnetforms-dashboard-item-category]:not([data-piotnetforms-dashboard-item-category="import"])';
			}

			$('[data-piotnetforms-dashboard-item-category]').removeClass('active');
			$(document).find(selector).addClass('active');
		})
	);

	$(document).on('click', '[data-settings-page-show-password-icon]', function(){
		let currentType = $(this).closest('.piotnetforms-settings-page-td').find('.regular-text').attr('type');
		let showPasswordIcon = $(this).find('.piotnetforms-settings-page-show-password-icon i');
		if(currentType == 'password'){
			$(this).closest('.piotnetforms-settings-page-td').find('.regular-text').attr('type', 'text');
			showPasswordIcon.addClass("fa-eye-slash");
		}else{
			$(this).closest('.piotnetforms-settings-page-td').find('.regular-text').attr('type', 'password');
			showPasswordIcon.removeClass("fa-eye-slash");
		}
	});
});
