export default class EditorSetting {
    keyStorage = 'piotnetforms-editor'
    defaultSetting = {
        'navigator': {
            'show': false,
        },
        'fullscreen': false,
    }

    getSetting() {
        try {
            let setting = JSON.parse(localStorage.getItem(this.keyStorage));
            if (!setting) {
                setting = this.defaultSetting;
            }
            return setting;
        } catch(err) {
            return this.defaultSetting;
        }
    }

    saveSetting(setting) {
        localStorage.setItem(this.keyStorage, JSON.stringify(setting));
    }

    isNavigatorShow() {
        try {
            const navigator = this.getSetting()['navigator'];
            return navigator && navigator['show'];
        } catch(err) {
            this.saveSetting(this.defaultSetting);
            return false;
        }
    }

    setNavigatorShow(isShow) {
        let setting = this.getSetting();
        try {
            setting['navigator']['show'] = isShow;
        } catch(err) {
            setting =  this.defaultSetting;
            setting['navigator']['show'] = isShow;
        }

        this.saveSetting(setting);
    }

    isFullscreen() {
        try {
            return this.getSetting()['fullscreen'];
        } catch(err) {
            this.saveSetting(this.defaultSetting);
            return false;
        }
    }

    setFullscreen(isFullscreen) {
        let setting = this.getSetting();
        try {
            setting['fullscreen'] = isFullscreen;
        } catch(err) {
            setting = this.defaultSetting;
            setting['fullscreen'] = isFullscreen;
        }

        this.saveSetting(setting);
    }
}