jQuery(document).ready(function( $ ) {
	function multiStepFormSignature( $selector ) {
		var $piotnetformsSingature = $selector.find('[data-piotnetforms-signature] canvas.not-resize');

		if ($piotnetformsSingature.length > 0) {
			$piotnetformsSingature.each(function(){
	    		var width = parseInt( $(this).css('max-width').replace('px','') ),
	    			height = parseInt( $(this).css('height').replace('px','') ),
	    			widthOuter = parseInt( $(this).closest('.piotnetforms-fields-wrapper').width() ); 

				if(widthOuter > 0) {
					if (width > widthOuter) {
						$(this).attr('width',widthOuter);
					} else {
						$(this).attr('width',width);
					}

					$(this).removeClass('not-resize');
				}
	    	});

		}
    }

	$(document).on('click','[data-piotnetforms-nav="next"]',function(e){
		e.preventDefault();
		nextMultiStepForm($(this));
	});

	function nextMultiStepForm($this) {
		var formID = $this.closest('[data-piotnetforms-multi-step-form-id]').attr('data-piotnetforms-multi-step-form-id'),
			$wrapper = $this.closest('.piotnetforms-multi-step-form__content-item'),
    		$fields = $wrapper.find('[data-piotnetforms-id="'+ formID +'"]'),
    		requiredText = $('[data-piotnetforms-submit-form-id="' + formID + '"]').attr('data-piotnetforms-required-text'), 
    		error = 0;
    	var isAlertRequired = false;

		$fields.each(function(){
			if ( $(this).data('piotnetforms-stripe') == undefined && $(this).data('piotnetforms-html') == undefined ) {
				var $checkboxRequired = $(this).closest('.piotnetforms-field-type-checkbox.piotnetforms-field-required');
				var checked = 0;
				if ($checkboxRequired.length > 0) {
					checked = $checkboxRequired.find("input[type=checkbox]:checked").length;
				} 

				if ($(this).attr('oninvalid') != undefined) {
					requiredText = $(this).attr('oninvalid').replace("this.setCustomValidity('","").replace("')","");
				}

				var isValid = $(this)[0].checkValidity();
				var next_ele = $($(this)[0]).next()[0];
				if ($(next_ele).hasClass('flatpickr-mobile')) {
					isValid = next_ele.checkValidity();
				}

				if ( !isValid && $(this).closest('.piotnetforms-conditional-logic-hidden').length == 0 && $(this).closest('[data-piotnetforms-conditional-logic]').css('display') != 'none' &&  $(this).closest('[data-piotnetforms-signature]').length == 0 || checked == 0 && $checkboxRequired.length > 0 && $(this).closest('.piotnetforms-fields-wrapper').css('display') != 'none') {
					if ($(this).css('display') == 'none' || $(this).data('piotnetforms-image-select') != undefined || $checkboxRequired.length > 0) {
						$(this).closest('.piotnetforms-field-group').find('[data-piotnetforms-required]').html(requiredText);
					} else {
						if (!isAlertRequired && $(this).data('piotnetforms-image-select') == undefined) {
							$(this)[0].reportValidity();
							isAlertRequired = true;
						}
					}
					error++; 
				} else {
					if ($(this).val()=='' && $(this).closest('.piotnetforms-conditional-logic-hidden').length == 0 && $(this).attr('aria-required') == "true" && $(this).attr('data-piotnetforms-select-autocomplete') !== undefined) {
						$(this).closest('.piotnetforms-field-group').find('[data-piotnetforms-required]').html(requiredText);
						error++;
					} else {

						if ( $(this).data('piotnetforms-image-select') != undefined ) {
							if ( $(this).closest('.piotnetforms-image-select-field').find('.image_picker_selector').find('.selected').length < $(this).data('piotnetforms-image-select-min-select') ) {
								$(this).closest('.piotnetforms-field-group').find('[data-piotnetforms-image_select_min_select_check]').html($(this).data('piotnetforms-image-select-min-select-message'));
								error++;
							} else {
								$(this).closest('.piotnetforms-field-group').find('[data-piotnetforms-image_select_min_select_check]').remove();
							}
						}

						$(this).closest('.piotnetforms-field-group').find('[data-piotnetforms-required]').html('');

						if ( $(this).data('piotnetforms-flatpickr-custom-options') != undefined ) {
							if ($(this).val() == '' && $(this).closest('.piotnetforms-conditional-logic-hidden').length == 0 && $(this).attr('required') != undefined) {
								$(this).closest('.piotnetforms-field-group').find('[data-piotnetforms-required]').html(requiredText);
								error++;
							}
						}

						if ($(this).closest('[data-piotnetforms-signature]').length > 0) {
							var $piotnetformsSingature = $(this).closest('[data-piotnetforms-signature]'),
								$exportButton = $piotnetformsSingature.find('[data-piotnetforms-signature-export]');

							$exportButton.trigger('click');

							if ($(this).val() == '' && $(this).closest('.piotnetforms-conditional-logic-hidden').length == 0 && $(this).attr('required') != undefined) {
								$(this).closest('.piotnetforms-field-group').find('[data-piotnetforms-required]').html(requiredText);
								error++;
							}
						}
					}
				}
			}
		});

		if (error == 0) {
			$wrapper.removeClass('active');
			let $wrapperNext = $wrapper.next();
			$wrapperNext.addClass('active');
			var index = $wrapperNext.index(),
				$progressbarItem = $this.closest('.piotnetforms-multi-step-form').find('.piotnetforms-multi-step-form__progressbar-item');
			$progressbarItem.eq(index).addClass('active');

			var $scrollToTop = $this.closest('[data-piotnetforms-multi-step-form-scroll-to-top]');

			if ($scrollToTop.length > 0) {
				var breakPointMd = $('[data-piotnetforms-break-point-md]').data('piotnetforms-break-point-md'),
					breakPointLg = $('[data-piotnetforms-break-point-lg]').data('piotnetforms-break-point-lg'),
					windowWidth = window.innerWidth;

				if( windowWidth >= breakPointLg ) {
					$('html, body').animate({
						scrollTop: $scrollToTop.offset().top - $scrollToTop.data('piotnetforms-multi-step-form-scroll-to-top-offset-desktop') }
					, 300);
				}

				if( windowWidth >= breakPointMd && windowWidth < breakPointLg ) {
					$('html, body').animate({
						scrollTop: $scrollToTop.offset().top - $scrollToTop.data('piotnetforms-multi-step-form-scroll-to-top-offset-tablet') }
					, 300);
				}

				if( windowWidth < breakPointMd ) {
					$('html, body').animate({
						scrollTop: $scrollToTop.offset().top - $scrollToTop.data('piotnetforms-multi-step-form-scroll-to-top-offset-mobile') }
					, 300);
				}
			}

			multiStepFormSignature( $wrapperNext );
			
			piotnetformsMultiStepAnimation($wrapper.closest('form').find('.piotnetforms-multi-step-form__content-item.active'));
		}
	}

	piotnetformsMultiStepAnimation($('.piotnetforms-multi-step-form__content-item.active'));

	function piotnetformsMultiStepAnimation($wrapper) {
		let $animations = $wrapper.find('[data-piotnetforms-animation]');

		$animations.each(function(){
			$(this).attr('class', function(i, c){
			    return c.replace(/(^|\s)animate__\S+/g, '');
			});
			
			let animationClass = 'animate__animated animate__' + $(this).attr('data-piotnetforms-animation'),
				animationDelay = parseInt( $(this).attr('data-piotnetforms-animation-delay') ),
				$this = $(this);

			if (animationDelay > 0) {
				setTimeout(function(){
					$this.addClass(animationClass);
				}, animationDelay);
			} else {
				$(this).addClass(animationClass);
			}
		});
	}

	$(document).on('change','[data-piotnetforms-multi-step-form-autonext]',function(){
		nextMultiStepForm($(this));
	});

	$(document).on('click','.image_picker_selector>li>div',function(){
		if ($(this).closest('.piotnetforms-field').find('[data-piotnetforms-multi-step-form-autonext]').length > 0) {
			nextMultiStepForm($(this));
		}
	});

	$(document).on('keyup', function(e){
		if(e.keyCode === 13){
			let $pressEnterNext = $(document).find('.piotnetforms-multi-step-form__content-item.active [data-piotnetforms-press-enter-next]');
			if ($pressEnterNext.length > 0) {
				$pressEnterNext.each(function(){
					nextMultiStepForm($(this));
				});
			}
		}
	});

	$(document).on('click','[data-piotnetforms-nav="prev"]',function(e){
		e.preventDefault();
		
		var formID = $(this).closest('[data-piotnetforms-multi-step-form-id]').attr('data-piotnetforms-multi-step-form-id'),
			$wrapper = $(this).closest('.piotnetforms-multi-step-form__content-item'),
			$wrapperPrev = $wrapper.prev();

		$wrapper.removeClass('active');
		$wrapperPrev.addClass('active');
		var index = $wrapper.index(),
			$progressbarItem = $(this).closest('.piotnetforms-multi-step-form').find('.piotnetforms-multi-step-form__progressbar-item');
		$progressbarItem.eq(index).removeClass('active');

		var $scrollToTop = $(this).closest('[data-piotnetforms-multi-step-form-scroll-to-top]');

		if ($scrollToTop.length > 0) {
			var breakPointMd = $('[data-piotnetforms-break-point-md]').data('piotnetforms-break-point-md'),
				breakPointLg = $('[data-piotnetforms-break-point-lg]').data('piotnetforms-break-point-lg'),
				windowWidth = window.innerWidth;

			if( windowWidth >= breakPointLg ) {
				$('html, body').animate({
					scrollTop: $scrollToTop.offset().top - $scrollToTop.data('piotnetforms-multi-step-form-scroll-to-top-offset-desktop') }
				, 300);
			}

			if( windowWidth >= breakPointMd && windowWidth < breakPointLg ) {
				$('html, body').animate({
					scrollTop: $scrollToTop.offset().top - $scrollToTop.data('piotnetforms-multi-step-form-scroll-to-top-offset-tablet') }
				, 300);
			}

			if( windowWidth < breakPointMd ) {
				$('html, body').animate({
					scrollTop: $scrollToTop.offset().top - $scrollToTop.data('piotnetforms-multi-step-form-scroll-to-top-offset-mobile') }
				, 300);
			}
		}

		piotnetformsMultiStepAnimation($wrapper.closest('form').find('.piotnetforms-multi-step-form__content-item.active'));
	});
});