export default class ObjectUtil {
    static getType(obj) {
        const str = Object.prototype.toString.call(obj);
        const map = {
            '[object Boolean]': 'boolean',
            '[object Number]': 'number',
            '[object String]': 'string',
            '[object Function]': 'function',
            '[object Array]': 'array',
            '[object Date]': 'date',
            '[object RegExp]': 'regExp',
            '[object Undefined]': 'undefined',
            '[object Null]': 'null',
            '[object Object]': 'object'
        };
        if (obj instanceof Element) {
            return 'element';
        }
        return map[str];
    }


    static deepCopy(ori) {
        const type = ObjectUtil.getType(ori);
        let copy;
        switch (type) {
            case 'array':
                return ObjectUtil.copyArray(ori, type, copy);
            case 'object':
                return ObjectUtil.copyObject(ori, type, copy);
            case 'function':
                return ObjectUtil.copyFunction(ori, type, copy);
            default:
                return ori;
        }
    }

    static copyArray(ori, type, copy = []) {
        for (const [index, value] of ori.entries()) {
            copy[index] = ObjectUtil.deepCopy(value);
        }
        return copy;
    }

    static copyObject(ori, type, copy = {}) {
        for (const [key, value] of Object.entries(ori)) {
            copy[key] = ObjectUtil.deepCopy(value);
        }
        return copy;
    }

    static copyFunction(ori, type, copy = () => {}) {
        console.log('hit');
        const fun = eval(ori.toString());
        fun.prototype = ori.prototype
        return fun
    }

    static clone(obj) {
        return ObjectUtil.deepCopy(obj);
    }
}
